#include <math.h>
#include "complessi.h"
				/* ### */
double modulo(a)
     COMPLESSO a;
{
  return(sqrt(a.re*a.re+a.im*a.im));
}
                                /* ### */
double argomento(a)
     COMPLESSO a;
{
  return(atan2(a.im,a.re));
}
                                /* ### */
COMPLESSO coniugato(a)
     COMPLESSO a;
{
  COMPLESSO b;
  b.re = a.re; b.im = -a.im;
  return(b);
}
                                /* ### */
COMPLESSO somma(a,b)
     COMPLESSO a,b;
{
  COMPLESSO ris;
  ris.re = a.re+b.re;
  ris.im = a.im+b.im;
  return(ris);
}
                                /* ### */
COMPLESSO prodotto(a,b)
     COMPLESSO a,b;
{
  COMPLESSO ris;
  ris.re = a.re*b.re-a.im*b.im;
  ris.im = a.re*b.im+a.im*b.re;
  return(ris);
}
/* ### */
COMPLESSO rapporto(a,b)
     COMPLESSO a,b;
{
  COMPLESSO ris;
  double d;
  d = 1./(b.re*b.re+b.im*b.im);
  ris.re = (a.re*b.re+a.im*b.im)*d;
  ris.im = (b.re*a.im-b.im*a.re)*d;
  return(ris);
}
                                /* ### */
COMPLESSO inverso(a)
     COMPLESSO a;
{
  COMPLESSO ris;
  double d;
  d = 1./(a.re*a.re+a.im*a.im);
  ris.re = a.re*d;
  ris.im = -a.im*d;  
  return(ris);
}
