#include <stdio.h>
				/* ### */
int contabyte(in,cont)
     FILE *in;
     int cont[];
     /* Legge byte a byte il file in, e restituisce nel vettore
	ctab il conteggio del numero di apparizioni di ciascun
	carattere nel file. 
	ATTENZIONE: ctab deve essere un vettore int di 256 elementi, 
	pena l'invasione di memoria.
	Restituisce la tabella riempita ed il numero totale di 
	caratteri letti.
     */
{
  int j,tot;
  unsigned char c;
				/* Azzeramento della tabella dei contatori */
  for(j=0;j<256;cont[j++]=0);
 				/* Procedo a contare i caratteri */
  while(fread(&c,sizeof(char),1,in) != 0) {
    ++cont[c];
    ++tot;
  }
  return(tot);
}
				/* ### */
void stampa_cont(cont)
     int cont[];
     /* Stampa la tabella dei contatori restituita dalle funzioni di
	statistica dei caratteri */
{
  int i,j;
  double percen,tot;
				/* Calcolo la somma dei contatori */
  for(tot=0.,j=0; j<256; tot+=cont[j++]);
				/* E stampo la tabella su 4 colonne */
  for(j=0;j<64;j++) {
    for(i=j;i<256;i+=64) {
      percen = 100.*((double) cont[i])/((double) tot);
    if((i > 31 && i < 127) || (i > 160)) 
      printf("\\%03o %c %6d %6.2f |  ",i,i,cont[i],percen);
    else
      printf("\\%03o %c %6d %6.2f |  ",i,' ',cont[i],percen);
    }
    printf("\n");
  }
  return;
}
				/* ### */
int main()
{
  FILE *in;
  int cont[256],tot,j;
  char nomfil[256];
                                /* Apertura del file in lettura, con
				   controllo di errore.  Sono
				   consentiti al massimo 3 errori. */
  for(j=0;;) {
    printf("Dimmi che file devo esaminare: ");
    scanf("%s",nomfil);
    if((in = fopen(nomfil,"r")) != NULL) break;
    else {
      printf("Errore nell'apertura del file in lettura:\n");
      perror(nomfil);
      if((++j) == 3) {
	printf("Hai sbagliato per tre volte. Vergognati!\n");
	exit(1);
      }
    }
  }
  tot=contabyte(in,cont);
  fclose(in);
  printf("Ho letto %d caratteri.\n\n",tot);
  stampa_cont(cont);  
  exit(0);
}
